// import { Axis } from './axis.js'
// export 
class FloatAxis extends Axis {
    constructor() {
        super()
    }
    calcTicks() {
        let range = this.range
        let delta = range[1] - range[0]
        let log = Math.round(Math.log10(delta))
        let min, max
        if (log > 0) {
            let pow = Math.pow(10, log - 1)
            min = Math.round(range[0] / pow) * pow
            max = Math.round(range[1] / pow) * pow
        } else {
            min = Math.round(range[0] * Math.pow(10, -log)) / Math.pow(10, -log)
            max = Math.round(range[1] * Math.pow(10, -log)) / Math.pow(10, -log)
        }
        let calcStep = (max - min) / this.ticksCount
        let step
        if (log > 0) {
            let pow = Math.pow(10, log - 1)
            step = Math.round(calcStep / pow) * pow
        } else {
            step = Math.round(calcStep * Math.pow(10, -log)) / Math.pow(10, -log)
        }
        if (step == 0) step = calcStep
        let ticks = []
        let labels = []
        let end = max + step
        let x = min
        while (x < end) {
            ticks.push(x)
            labels.push(this.formatLabel(x, log - 2))
            x += step
        }
        this._ticks = ticks
        this._labels = labels
    }
    formatLabel(value, log) {
        if (log < 0) {
            return value.toFixed(-log)
        } else {
            return ~~value + ""
        }
    }
}
