// import { Viewport } from './viewport.js'
// import { MouseNavigation } from './navigation/mouseNavigation.js'
// import { MouseEventArgs } from './navigation/mouseEventArgs.js'
// export 
class Chart {
    constructor() {
        this.elements = []
        this._viewport = new Viewport()
    }
    get viewport() {
        return this._viewport
    }
    add(element) {
        element.attach(this)
        this.elements.push(element)
    }
    remove(element) {
        element.detach(this)
        this.elements.remove(element)
    }
    mouseDown(mouseEventArgs) {
        this._raiseMouseEvent('onMouseDown', mouseEventArgs)
    }
    mouseMove(mouseEventArgs) {
        this._raiseMouseEvent('onMouseMove', mouseEventArgs)
    }
    mouseUp(mouseEventArgs) {
        this._raiseMouseEvent('onMouseUp', mouseEventArgs)
    }
    mouseWheel(mouseEventArgs) {
        this._raiseMouseEvent('onMouseWheel', mouseEventArgs)
    }
    * _hits(mouseEventArgs) {
        let list = []
        for (let element of this.elements) {
            if (element instanceof MouseNavigation) {
                if (element.hit(mouseEventArgs)) {
                    list.push(element)
                }
            }
        }
        list = list.reverse()
        for (let element of list) {
            yield element
        }
    }
    _raiseMouseEvent(key, mouseEventArgs) {
        for (let element of this._hits(mouseEventArgs)) {          
            element[key](mouseEventArgs)
            if (mouseEventArgs.isPrevent) break
        }
    }
}