// import { FloatHorizontalAxis } from '../chart/axis/floatHorizontalAxis.js'
// export 
class HorizontalAxisDrawing extends FloatHorizontalAxis {
    constructor() {
        super()
    }
    render(context, [left, top, width, height]) {
        context.beginPath()
        context.moveTo(left, top)
        context.lineTo(left + width, top)
        context.stroke()

        this.calcTicks()
        let ticks = this.ticks
        let labels = this.labels
        let ticksLength = this.ticksLength

        context.save()
        context.font = '14px sans-serif'
        let y = top
        for (let i = 0, length = ticks.length; i < length; i++) {
            let x = this.viewport.transformX(ticks[i], [left, top, width, height])
            context.beginPath()
            context.moveTo(x, y)
            context.lineTo(x, y + ticksLength)
            context.stroke()
            context.fillText(labels[i], x - labels[i].length * 4, y + ticksLength + 14)
        }
        context.restore()

    }

}