// import { MouseNavigation } from '../chart/navigation/mouseNavigation.js'
// import { MouseEventArgs } from '../chart/navigation/mouseEventArgs.js'
// export 
class MouseNavigationDrawing extends MouseNavigation {
    constructor() {
        super()
        this.start = []
        this.draging = false
        this.screen = []
    }
    hit(mouseEventArgs) {
        if (this.draging) return true
        let e = mouseEventArgs
        if (e.area == this.area)
            return true
        return false
    }
    onMouseDown(mouseEventArgs) {
        let e = mouseEventArgs
        e.prevent()
        let ieLeftDown = this._isLeftDown(e)
        console.log(e)
        if (ieLeftDown) {
            this._startDrag(e)
        }
    }
    _startDrag(e) {
        this.start = [e.x, e.y]
        this.draging = true
        this.screen = e.screen
    }
    _stopDrag() {
        this.start = [0, 0]
        this.draging = false
    }
    _isLeftDown(e) {
        return e.event.button == 0
    }
    onMouseMove(mouseEventArgs) {
        let e = mouseEventArgs
        if (this.draging && this._isLeftDown(e)) {
            e.prevent()
            let startX = this.start[0]
            let startY = this.start[1]
            let width = this.screen[2]
            let height = this.screen[3]
            var deltaX = e.x - startX
            var deltaY = e.y - startY

            let visibleLeft = this.viewport.visible[0]
            let visibleBottom = this.viewport.visible[1]
            let visibleWidth = this.viewport.visible[2] - visibleLeft
            let visibleHeight = this.viewport.visible[3] - visibleBottom

            var offsetX = deltaX / width * visibleWidth
            var offsetY = deltaY / height * visibleHeight

            this.start = [e.x, e.y]
            this.viewport.offset(-offsetX, offsetY)
        }
    }
    onMouseUp(mouseEventArgs) {
        let e = mouseEventArgs
        if (this.draging) {
            e.prevent()
            this._stopDrag()
        }
    }
    onMouseWheel(mouseEventArgs) {
        let e = mouseEventArgs
        e.prevent()
        let delta = 0.1 * e.event.wheelDeltaY / 120;
        this.viewport.zoom(-delta)
    }
}