// import { FloatVerticalAxis } from '../chart/axis/floatVerticalAxis.js'
// export 
class VerticalAxisDrawing extends FloatVerticalAxis {
    constructor() {
        super()
    }
    render(context, [left, top, width, height]) {
        context.beginPath()
        context.moveTo(left + width, top)
        context.lineTo(left + width, height)
        context.stroke()

        this.calcTicks()
        let ticks = this.ticks
        let labels = this.labels
        let ticksLength = this.ticksLength

        context.save()
        context.font = '14px sans-serif'
        let x = left + width - ticksLength
        for (let i = 0, length = ticks.length; i < length; i++) {
            let y = this.viewport.transformY(ticks[i], [left, top, width, height])
            context.beginPath()
            context.moveTo(x, y)
            context.lineTo(x + ticksLength, y)
            context.stroke()
            context.fillText(labels[i], x - ticksLength - labels[i].length * 5, y + 7)
        }
        context.restore()
    }
}