// import { Chart } from './chart/chart.js'
// import { CanvasDrawing } from './drawing/canvasDrawing.js'
// import { VerticalAxisDrawing } from './drawing/verticalAxisDrawing.js'
// import { HorizontalAxisDrawing } from './drawing/horizontalAxisDrawing.js'
// import { LineDrawing } from './drawing/lineDrawing.js'
(function () {
    var width = 800
    var height = 600
    var dataCount = 1000
    var chart = new Chart()
   
  
    chart.add(new VerticalAxisDrawing())
    chart.add(new HorizontalAxisDrawing())
    chart.add(new MouseNavigationDrawing())
    var chartDrawing = new CanvasDrawing(width, height)
    chartDrawing.init(document.body, chart)
    var lines = [];
    for (let index = 0; index < 50; index++) {
        var lineDrawing = new LineDrawing()
        chart.add(lineDrawing)
        lines.push(lineDrawing);
    }
    chart.viewport.setVisible(0, -1 * lines.length, dataCount , 1 * lines.length)
    var e = s => document.querySelector(s)

    var fps = e('#fps')
    var step = 0
    var begintime = +new Date()
    var count = 0
    function run() {
        requestAnimationFrame(run)
        var now = +new Date()
        count = ((count + 1) % 16)
        if (count == 0) {
            fps.innerHTML = ~~(1000 / (now - begintime))
        }
        begintime = now
        step += 1
        
        for (let j = 0; j < lines.length; j++) {
            let lineDrawing = lines[j]
            lineDrawing.data = []
            for (let i = 0; i < dataCount; i++) {
                lineDrawing.data.push(i)
                lineDrawing.data.push((j + 1) * Math.sin((step + i) * (360 * 4 / width) * Math.PI / 180))
            }
        }
        chartDrawing.renderChart(chart)
    }
    run()
})()
